Leetcode: Can I Win

In the "100 game," two players take turns adding, to a running total, any integer from 1..10. The player who first causes the running total to reach or exceed 100 wins.

What if we change the game so that players cannot re-use integers?

For example, two players might take turns drawing from a common pool of numbers of 1..15 without replacement until they reach a total >= 100.

Given an integer maxChoosableInteger and another integer desiredTotal, determine if the first player to move can force a win, assuming both players play optimally.

You can always assume that maxChoosableInteger will not be larger than 20 and desiredTotal will not be larger than 300.

Example

Input:
maxChoosableInteger = 10
desiredTotal = 11

Output:
false

Explanation:
No matter which integer the first player choose, the first player will lose.
The first player can choose an integer from 1 up to 10.
If the first player choose 1, the second player can only choose integers from 2 up to 10.
The second player will win by choosing 10 and get a total = 11, which is >= desiredTotal.
Same with other integers chosen by the first player, the second player will always win.

refer to https://discuss.leetcode.com/topic/68896/java-solution-using-hashmap-with-detailed-explanation

After solving several "Game Playing" questions in leetcode, I find them to be pretty similar. Most of them can be solved using the top-down DP approach, which "brute-forcely" simulates every possible state of the game.

The key part for the top-down dp strategy is that we need to avoid repeatedly solving sub-problems. Instead, we should use some strategy to "remember" the outcome of sub-problems. Then when we see them again, we instantly know their result. By doing this, we can always reduce time complexity from exponential to polynomial.
(EDIT: Thanks for @billbirdh for pointing out the mistake here. For this problem, by applying the memo, we at most compute for every subproblem once, and there are O(2^n) subproblems, so the complexity is O(2^n) after memorization. (Without memo, time complexity should be like O(n!))

For this question, the key part is: what is the state of the game? Intuitively, to uniquely determine the result of any state, we need to know:

  1. The unchosen numbers
  2. The remaining desiredTotal to reach

A second thought reveals that 1) and 2) are actually related because we can always get the 2) by deducting the sum of chosen numbers from original desiredTotal.

Then the problem becomes how to describes the state using 1).

In my solution, I use a boolean array to denote which numbers have been chosen, and then a question comes to mind, if we want to use a Hashmap to remember the outcome of sub-problems, can we just use Map<boolean[], Boolean> ? Obviously we cannot, because the if we use boolean[] as a key, the reference to boolean[] won't reveal the actual content in boolean[].

Since in the problem statement, it says maxChoosableInteger will not be larger than 20, which means the length of our boolean[] array will be less than 20. Then we can use an Integer to represent this boolean[] array. How?

Say the boolean[] is {false, false, true, true, false}, then we can transfer it to an Integer with binary representation as 00110. Since Integer is a perfect choice to be the key of HashMap, then we now can "memorize" the sub-problems using Map<Integer, Boolean>.

The rest part of the solution is just simulating the game process using the top-down dp.

他的code精妙之处在于:

1. HashMap的key是由boolean array encode生成的,直接用一个array作hashmap的key是不行的,HashMap fails to get the keys when a different array is passed as key, although the elements are same. (As they are different objects). 感觉用object作key都会有这个问题,除非是同一个object,否则仅仅值相等并不指引正确的位置。所以作者在这里encode成了primative type

2. 14行的结束条件。我曾经想过维护TreeSet, treeset.ceiling(desired) != null表示存在大于desired的unused elem, 则return true; 或者维护一个hashset visited, 然后扫描一遍return true; 这些方法都不如作者的这个来的简洁

3. 22行,我写的时候没有把visited reset为false

 1 public class Solution {
 2     HashMap<Integer, Boolean> map;
 3     boolean[] visited;
 4     public boolean canIWin(int maxChoosableInteger, int desiredTotal) {
 5         int sum = (1+maxChoosableInteger)*maxChoosableInteger/2;
 6         if (sum < desiredTotal) return false;
 7         if (desiredTotal <= 0) return true;
 8         map = new HashMap<Integer, Boolean>();
 9         visited = new boolean[maxChoosableInteger+1];
10         return helper(desiredTotal);
11     }
12     
13     public boolean helper(int desired) {
14         if (desired <= 0) return false; //base case, means the player played last time already reach the desired total, so the current player has no chance to win
15         int key = calcKey(visited);
16         if (map.containsKey(key)) return map.get(key);
17         else {
18             for (int i=1; i<visited.length; i++) {
19                 if (!visited[i]) {
20                     visited[i] = true;
21                     if (!helper(desired-i)) {
22                         visited[i] = false;
23                         map.put(key, true);
24                         return true;
25                     }
26                     visited[i] = false;
27                 }
28             }
29             map.put(key, false);
30             return false;
31         }
32     }
33     
34     public int calcKey(boolean[] visited) {
35         int res = 0;
36         for (int i=0; i<visited.length; i++) {
37             if (visited[i]) {
38                 res |= 1;
39             }
40             res = res << 1;
41         }
42         return res;
43     }
44 }

Solution 2: 我的backtracking做法,TLE了,但是思路应该还可以, 用的是treeSet,用来表示还可以使用的数,之所以这样做是因为当时只想到return true的base case。不过我的方法好处是不用visited数组

 1 public class Solution {
 2     public boolean canIWin(int maxChoosableInteger, int desiredTotal) {
 3         int sum = (1+maxChoosableInteger)*maxChoosableInteger/2;
 4         if(sum < desiredTotal) return false;
 5         if(desiredTotal <= 0) return true;
 6         
 7         TreeSet<Integer> set = new TreeSet<Integer>();
 8         for (int i=1; i<=maxChoosableInteger; i++) {
 9             set.add(i);
10         }
11         return canWin(set, maxChoosableInteger, desiredTotal);
12     }
13     
14     public boolean canWin(TreeSet<Integer> set, int max, int desired) {
15         if (set.ceiling(desired) != null) {
16             return true;
17         }
18         for (int num=1; num<=max; num++) {
19             if (!set.contains(num)) continue;
20             set.remove(num);
21             if (!canWin(set, max, desired-num)) {
22                 set.add(num);
23                 return true;
24             }
25             set.add(num);
26         }
27         return false;
28     }
29 }
原文地址:https://www.cnblogs.com/EdwardLiu/p/6168469.html